####################################################
# Blah Software Code      |    Software Version: 2 #
####################################################
#       Software: e-blah!                          #
# Copyrighted  2001-2002 e-blah!                  #
# All Rights Reserved                              #
####################################################

require("$language/Admin.lng");

sub Admin {
	&is_admin;
	if($URL{'a'} eq 'bkup') { require "$code/Backup.pl"; &BoardBackup; }
	elsif($URL{'a'} eq 'bkupstart') { require "$code/Backup.pl"; &BKUPStart; }
	elsif($URL{'a'} eq 'boards') { &EditBoards; }
	elsif($URL{'a'} eq 'cats') { &EditCats; }
	elsif($URL{'a'} eq 'repop') { &Repop; }
	elsif($URL{'a'} eq 'memgrps') { require("$code/Members.pl"); &MemGrps; }
	elsif($URL{'a'} eq 'temp') { &Temp; }
	elsif($URL{'a'} eq 'temp2') { &Temp2; }
	elsif($URL{'a'} eq 'iplog') { &IPLog; }
	elsif($URL{'a'} eq 'errorlog') { &ErrorLog; }
	elsif($URL{'a'} eq 'attlog') { require("$code/Attach.pl"); &AttachLog; }
	elsif($URL{'a'} eq 'clicklog') { &ClickLog; }
	elsif($URL{'a'} eq 'remem') { &Remem; }
	elsif($URL{'a'} eq 'killsids') { &KILLSID; }
	elsif($URL{'a'} eq 'version') { &Version; }
	elsif($URL{'a'} eq 'news') { &News; }
	elsif($URL{'a'} eq 'advipsearch') { require("$code/Members.pl"); &IPSearch; }
	elsif($URL{'a'} eq 'clearactive') { &ClearActive; }
	elsif($URL{'a'} eq 'remove') { require("$code/Moderate.pl"); &OldThreads; }
	elsif($URL{'a'} eq 'tempcon') { &TempConv; } ## Remove in FINAL!!
		else { require("$code/Admin2.pl"); &Admin2; }
}

sub TempConv {
	push(@conv,"$root/template.pl");
	push(@conv,"$prefs/Smilies.pl");
	opendir(DIR,$theme);
	@tlist = readdir(DIR);
	closedir(DIR);
	foreach(@tlist) {
		if($_ =~ /.pl/) { push(@conv,"$theme/$_"); }
	}
	$bad = 0;
	$counter = 0;
	foreach(@conv) {
		if(!-e($_)) { ++$bad; next; }
		++$counter;
		fopen(FILE,$_);
		@temp = <FILE>;
		fclose(FILE);
		chomp @temp;
		$_ =~ s/.pl\Z/.html/;
		if(-e($_)) { ++$bad; --$counter; next; }
		@array = '';
		fopen(FILE,">$_");
		foreach $temps (@temp) {
			if($temps eq "EOT" && $lifes) { $lifes = 0; push(@array,"<blah main>"); }
			elsif($temps eq "EOT") { $deaths = 0; }
			if($temps eq qq~\$footer = <<"EOT";~) { $deaths = 1; next; }
			if($temps eq qq~\$header = <<"EOT";~) { $lifes = 1; next; }
			$temps =~ s/\$title/<blah v="\$title">/gsi;
			$temps =~ s/\$mbname/<blah v="\$mbname">/gsi;
			$temps =~ s/\$displayuser/<blah v="\$displayuser">/gsi;
			$temps =~ s/\$version/<blah v="\$version">/gsi;
			$temps =~ s/\$date_time/<blah v="\$date_time">/gsi;
			$temps =~ s/\$menubar/<blah v="\$menubar">/gsi;
			$temps =~ s/\$copyright/<blah v="\$copyright">/gsi;
			$temps =~ s/\$color{'win'}/$color{'win'}/gsi;
			$temps =~ s/\$color{'win2'}/$color{'win2'}/gsi;
			$temps =~ s/\$color{'titlebg'}/$color{'titlebg'}/gsi;
			$temps =~ s/\$color{'catbg'}/$color{'catbg'}/gsi;
			$temps =~ s/\$color{'border'}/$color{'border'}/gsi;
			if($lifes) { push(@array,$temps); }
			if($deaths) { push(@array,$temps); }
		}
		foreach $arr (@array) { print FILE "$arr\n"; }
		fclose(FILE);
	}
	fopen(FILE,"$prefs/RTemp.txt");
	@temp = <FILE>;
	fclose(FILE);
	chomp @temp;
	foreach(@temp) {
		if($_ eq '$rtemp = <<"EOF";') { next; }
		if($_ eq 'EOF') { $start = 1; last; }
		$append .= "$_\n";
	}
	if($start) {
		fopen(FILE,">$prefs/RTemp.txt");
		print FILE $append;
		fclose(FILE);
	}
	$title = "Temp Conversion";
	&header;
	print <<"EOT";
<font size="2" face="verdana"><b>Successfully converted Templates:</b> $counter<br>
<b>Templates that could not be converted:</b> $bad (this <b>could</b> be because they have already been converted)<BR><BR><b>Finished Converting Templates ...</b></font>
EOT
	&footer;
	exit;
}

sub ClearActive {
	unlink("$prefs/Active.txt");
	&redirect("$scripturl,v=admin");
}

sub LoadModifications {
	# When you make a modification to Blah, add it here in the following format:
	  # - push(@bdmod,"Modification Name");
	# YaBB Security Mod
	$ypon = $yabbconver ? $admintxt[2] : $admintxt[3];
	push(@bdmod,"$admintxt[1] (<b>$ypon</b>)");	# This mod is installed by default for boards which used the "YaBB Security Mod"

	# Do not mess with anything below ... it's for adding the mod to the list.
	foreach(@bdmod) { $bdmods .= "$_<br>"; }
	$bdmods =~ s/<br>\Z//;
}

sub AdminCenter {
	@adminlist = FindRanks('Administrator');
	foreach(@adminlist) { $adminlist .= qq~<a href="$scripturl,v=profile,a=view,u=$_">$userset{$_}->[1]</a>, ~; }
	$adminlist =~ s/, \Z//;

	&LoadModifications;
	fopen(FILE,"$prefs/ReportPM.txt");
	@reports = <FILE>;
	fclose(FILE);
	chomp @reports;
	$reportpm = 0;
	foreach(@reports) {
		($t,$t,$t,$t,$t,$t,$t,$t,$recieveuser,$t,$t) = split(/\|/,$_);
		if($recieveuser eq $username || $recieveuser eq 'all admin') { ++$reportpm; }
	}

	$banninglog = 0;
	$activelog = 0;
	$clicklog = 0;
	$attlog = 0;
	$banlog = 0;
	$felog = 0;
	$areferals = 0;
	$referals = 0;
	$activesids = 0;
	$inactivesids = 0;

	fopen(FILE,"$prefs/ELog.txt");
	while(<FILE>) { ++$felog; }
	fclose(FILE);
	fopen(FILE,"$prefs/BanList.txt");
	while(<FILE>) { ++$banlog; }
	fclose(FILE);
	fopen(FILE,"$prefs/Attachments.txt");
	while(<FILE>) { ++$attlog; }
	fclose(FILE);
	fopen(FILE,"$prefs/ClickLog.txt");
	while(<FILE>) { ++$clicklog; }
	fclose(FILE);
	fopen(FILE,"$prefs/Active.txt");
	while(<FILE>) { ++$activelog; }
	fclose(FILE);
	fopen(FILE,"$prefs/NoAccess.txt");
	while(<FILE>) { ++$banninglog; }
	fclose(FILE);
	fopen(FILE,"$prefs/Refer.txt");
	while(<FILE>) { ++$areferals; }
	fclose(FILE);
	fopen(FILE,"$prefs/ReferLog.txt");
	while(<FILE>) { ++$referals; }
	fclose(FILE);
	fopen(FILE,"$prefs/Sids.sid");
	@sids = <FILE>;
	fclose(FILE);
	chomp @sids;
	foreach(@sids) {
		($t,$t,$t,$t,$endtime,$baccess) = split(/\|/,$_);
		if($endtime > time) { ++$activesids; } else { ++$inactivesids; }
	}
	if($inactivesids) { $inactivesids .= qq~ <b>:: <a href="javascript:clear('$scripturl,v=admin,a=killsids')">$admintxt[4]</a></b>~; }

	opendir(DIR,"$theme/");
	@themes = readdir(DIR);
	closedir(DIR);
	foreach(@themes) {
		$themename = $_;
		$themename =~ s/ /\+/gsi;
		if($_ =~ m/(.*)(.v1)/) { $themes .= qq~$1<br>~; }
	}
	$themes =~ s/<br>\Z//;
	if($themes eq '') { $themes = $admintxt[5]; }
	$ENV{'OS'} =~ s/_/ /gsi;

	if($activelog >= 0) { $systemstatus = $admintxt[166]; }
	if($activelog > 19 || $clicklog > 2499) { $systemstatus = $admintxt[167]; }
	if($activelog > 39 || $clicklog > 4999) { $systemstatus = $admintxt[166]; }
	if($felog) { $systemstatus .= " $admintxt[164]"; }

	$clicklog = MakeComma($clicklog);
	$logcnt = $logcnt > 59 ? sprintf("%.0f",($logcnt/60))." $gtxt{'3'}" : "$logcnt $gtxt{'2'}";

	$title = $admintxt[6];
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url,url2,explain) {
 if(!explain) { explain = "$admintxt[7]"; }
 if(window.confirm(explain)) { location = url; }
  else {
   if(url2) { location = url2; }
  }
}
// -->
</script>
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" colspan=2><font size="2"><b><img src="$images/admin_sm.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" width="50%" align="center"><font size="1"><b>$mbname :: $title<hr color="$color{'border'}" size="1"><font size="1"><b>$date_time<br><img src="$images/keys.gif"> $admintxt[8]<br>$admintxt[9]: $pmcnt ($new $admintxt[10])</font></b></font></td>
  <td bgcolor="$color{'win'}" width="50%"><font size="1">$admintxt[11], <b>$settings[1]</b>! $admintxt[12] <a href="http://www.eblah.com/cgi-bin/bb/Blah.pl?,v=mindex,b=btech">$admintxt[13]</a>.</font></td>
 </tr>
</table><br>
<table cellpadding="0" cellspacing="0" width="750" align="center">
 <tr>
  <td valign="top">
   <table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="372">
    <tr>
     <td bgcolor="$color{'catbg'}"><font size="2"><b><img src="$images/open_thread.gif"> $admintxt[14]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win'}" valign="top">
      <table cellpadding="1" cellspacing="0" width="100%">
       <tr>
        <td width="50%"><font size="1"><b>  <a href="$scripturl,v=admin,a=sets">$admintxt[16]</a><br>
          <a href="$scripturl,v=admin,a=boards">$admintxt[43]</a><br>
          <a href="$scripturl,v=admin,a=smiley">$admintxt[44]</a><br>
          <a href="$scripturl,v=admin,a=censor">$admintxt[46]</a><br>
        </td><td width="50%"><font size="1"><b>  <a href="$scripturl,v=admin,a=themesman">$admintxt[47]</a><br>
          <a href="$scripturl,v=admin,a=advipsearch">$admintxt[48]</a><br>
          <a href="$scripturl,v=admin,a=news">$admintxt[49]</a><br>
          <a href="$scripturl,v=admin,a=sourcemod">$admintxt[50]</a></b></font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" valign="top"><font size="2"><b><img src="$images/xx.gif"> $admintxt[51]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win'}"  valign="top"><font size="1"><b>
       <a href="$scripturl,v=admin,a=temp">$admintxt[52]</a><br>
       <a href="$scripturl,v=admin,a=regtemp">$admintxt[53]</a></b></font></td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" valign="top"><font size="2"><b><img src="$images/profile_sm.gif"> $admintxt[54]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win'}"  valign="top"><font size="1"><b>
       <a href="$scripturl,v=admin,a=memgrps">$admintxt[55]</a><br>
       <a href="$scripturl,v=admin,a=reports">$admintxt[56]</a><br>
       <a href="javascript:clear('$scripturl,v=admin,a=mailing','$scripturl,v=admin,a=mailing,s=all','$admintxt[57]');">$admintxt[58]</a></b></font></td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" valign="top"><font size="2"><b><img src="$images/ban.gif"> $admintxt[59]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win'}" valign="top">
      <table cellpadding="1" cellspacing="0" width="100%">
       <tr>
        <td width="50%"><font size="1"><b>  <a href="javascript:clear('$scripturl,v=admin,a=remem')">$admintxt[60]</a><br>
          <a href="$scripturl,v=admin,a=delspec">$admintxt[61]</a><br>
          <a href="$scripturl,v=admin,a=removemembers">$admintxt[62]</a><br>
        </td><td width="50%"><font size="1"><b>       <a href="javascript:clear('$scripturl,v=admin,a=posts','','$admintxt[159]')">$admintxt[160]</a><br>
          <a href="$scripturl,v=admin,a=validate">$admintxt[63]</a><br>
          <a href="$scripturl,v=admin,a=ban">$admintxt[45]</a></b></font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" valign="top"><font size="2"><b><img src="$images/ban.gif"> $admintxt[64]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win'}" valign="top"><font size="1"><b>
       <a href="$scripturl,v=admin,a=repop">$admintxt[65]</a><br>
       <a href="$scripturl,v=admin,a=bkup">$admintxt[66]</a><br>
       <a href="$scripturl,v=admin,a=remove">$admintxt[67]</a></b></font></td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" valign="top"><font size="2"><b><img src="$images/clicklog_sm.gif"> $admintxt[68]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win'}" valign="top">
      <table cellpadding="1" cellspacing="0" width="100%">
       <tr>
        <td width="50%"><font size="1"><b>  <a href="$scripturl,v=admin,a=attlog">$admintxt[69]</a><br>
          <a href="$scripturl,v=admin,a=banlog">$admintxt[70]</a><br>
          <a href="$scripturl,v=admin,a=clicklog">$admintxt[71]</a><br>
        </td><td width="50%"><font size="1"><b>  <a href="$scripturl,v=admin,a=errorlog">$admintxt[72]</a><br>
          <a href="$scripturl,v=admin,a=iplog">$admintxt[73]</a><br>
          <a href="$scripturl,v=admin,a=referals">$admintxt[74]</a></b></font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" valign="top"><font size="2"><b><img src="$images/convert.gif"> $admintxt[75]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win'}" valign="top"><font size="1"><b>  <a href="$surl,v=admin,a=convert,t=yabb">YaBB</a></b></font></td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" valign="top"><font size="2"><b><img src="$images/ban.gif"> Beta to Beta Utilities</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win'}" valign="top"><font size="1"><b>  <a href="$surl,v=admin,a=tempcon">Convert Templates</a></b></font></td>
    </tr>
   </table>
  </td>
  <td valign="top" align="right">
   <table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="372">
    <tr>
     <td bgcolor="$color{'catbg'}"><font size="2"><b><img src="$images/lamp.gif"> $admintxt[15]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}">

      <table cellpadding="2" cellspacing="0" width="100%">
       <tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[17]:</b></font></td>
        <td><font size="1">$regto</font></td>
       </tr><tr>
        <td colspan="2"><hr size="1" color="$color{'border'}"></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[18]:<br> <a href="$scripturl,v=members,a=groups">$admintxt[19]</a> </b></font></td>
        <td valign="top"><font size="1">$adminlist</font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}"><font size="2"><b><img src="$images/ip.gif"> $admintxt[161]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}">
      <table cellpadding="2" cellspacing="0" width="100%">
       <tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[163] ($logcnt):</b></font></td>
        <td valign="top"><font size="1">$systemstatus</font></td>
       </tr><tr>
        <td colspan="2"><hr size="1" color="$color{'border'}"></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[20]:</b></font></td>
        <td valign="top"><font size="1"><a href="$scripturl,v=admin,a=clicklog">$clicklog</a></font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[21]:</b></font></td>
        <td valign="top"><font size="1"><a href="$scripturl,v=admin,a=reports">$reportpm</a></font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[22]:</b></font></td>
        <td valign="top"><font size="1">$activelog <b>:: <a href="javascript:clear('$scripturl,v=admin,a=clearactive')">$admintxt[23]</a></b></font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[24]:</b></font></td>
        <td valign="top"><font size="1"><a href="$scripturl,v=admin,a=attlog">$attlog</a></font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[25]:</b></font></td>
        <td valign="top"><font size="1"><a href="$scripturl,v=admin,a=ban">$banlog</a></font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[26]:</b></font></td>
        <td valign="top"><font size="1"><a href="$scripturl,v=admin,a=errorlog">$felog</a></font></td>
       </tr><tr>
        <td colspan="2"><hr size="1" color="$color{'border'}"></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[27]:</b></font></td>
        <td valign="top"><font size="1"><a href="$scripturl,v=admin,a=banlog">$banninglog</a></font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[28]:</b></font></td>
        <td valign="top"><font size="1"><a href="$scripturl,v=admin,a=referals">$areferals</a></font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[29]:</b></font></td>
        <td valign="top"><font size="1"><a href="$scripturl,v=admin,a=referals">$referals</a></font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[30]:</b></font></td>
        <td valign="top"><font size="1">$activesids</font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[31]:</b></font></td>
        <td valign="top"><font size="1">$inactivesids</font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}"><font size="2"><b><img src="$images/login_sm.gif"> $admintxt[162]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}" align="center">
      <table cellpadding="2" cellspacing="0" width="100%"><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[32]:</b></font></td>
        <td valign="top"><font size="1">$bdmods<br><b> <a href="$scripturl,v=admin,a=sourcemod">$admintxt[33]</a></font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[34]:</b></font></td>
        <td valign="top"><font size="1">$themes</font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}"><font size="2"><b><img src="$images/question.gif"> $admintxt[146]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}" align="center">
      <table cellpadding="2" cellspacing="0" width="100%"><tr>
        <td align="right" width="45%" valign="top"><font size="1"><b>$admintxt[35]:</b></font></td>
        <td valign="top"><font size="1">$version<br><b> <a href="$scripturl,v=admin,a=version">$admintxt[36]</a></b></font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}"><font size="2"><b><img src="$images/admin_sm.gif"> $admintxt[37]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}" align="center">
      <table cellpadding="2" cellspacing="0" width="100%">
       <tr>
        <td align="right" width="45%" valign="top"><span style="cursor:default;"><font size="1"><b>$admintxt[38]:</b></font></span></td>
        <td valign="top"><font size="1"><span style="cursor:hand;"><a title="Thank you so, so much for dying for me! I love you!">Jesus</a>, <a title="Allowing me to switch them from Gamers.com to Blah">JFA</a>, <a title="Their support of the Blah Project">FP Community</a>, <a title="Good cell group! :) Thanks for using Blah!!">OOB</a>, <a title="Thanks for the eblah.com domain! :D">superfalon</a></span></font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><span style="cursor:default;"><font size="1"><b>$admintxt[39]:</b></font></span></td>
        <td valign="top"><font size="1">Justin</font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><span style="cursor:default;"><font size="1"><b>$admintxt[40]:</b></font></span></td>
        <td valign="top"><font size="1"><span style="cursor:hand;"><a title="Helped a little with Attachments, various file opening routines, and text to URL.">Dave B.</a>, <a title="Did the help that I was too lazy to do. ;D">DeathBox</a>, <a title="Got some Flash Code ...">Matrinix</a>, <a title="Found some bugs for me. :) Thanks!!">CLiX</a></span></font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><span style="cursor:default;"><font size="1"><b>$admintxt[41]:</b></font></span></td>
        <td valign="top"><font size="1"><span style="cursor:hand;"><a title="Found a ton of bugs, and reported 'em all back to me. :)">Fernando</a></span></font></td>
       </tr><tr>
        <td colspan="2" align="center"><span style="cursor:default;"><font size="1"><b>$admintxt[42]</b></font></span></td>
       </tr>
      </table>
     </td>
    </tr>
   </table>
  </td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub KILLSID {
	fopen(FILE,"$prefs/Sids.sid");
	while( $sid = <FILE> ) {
		chomp $sid;
		($tsid,$ip,$sidname,$t,$endtime) = split(/\|/,$sid);
		if($endtime > time) { $othersids .= "$sid\n"; }
	}
	fclose(FILE);
	fopen(FILE,"+>$prefs/Sids.sid");
	print FILE $othersids;
	fclose(FILE);
	&redirect("$scripturl,v=admin");
}

sub Remem {
	opendir(DIR,"$members/");
	@list = readdir(DIR);
	closedir(DIR);
	$memcnt = 0;
	foreach (sort @list) {
		if($_ =~ s/.dat\Z//) {
			&loaduser($_);
			if($userset{$_}->[14] > $lucnt) {
				$luser = $_;
				$lucnt = $userset{$_}->[14];
			}
			if($userset{$_}->[1]) { ++$memcnt; $memlistc .= "$_\n"; }
		}
	}
	fopen(LIST,"+>$members/List.txt");
	print LIST "$memlistc";
	fclose(LIST);
	fopen(FILE,"+>$members/LastMem.txt");
	print FILE "$luser\n$memcnt";
	fclose(FILE);
	if($URL{'v'} eq 'profile' || $URL{'a'} eq 'convert' || $URL{'a'} eq 'delspec' || $URL{'a'} eq 'removemembers') { return; }

	$title = $admintxt[76];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="400" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/profile_sm.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="2">$admintxt[77]</font></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub ClickLog {
	if($eclick != 1) { &error($admintxt[78]); }
	if($URL{'p'} eq 'delete') {
		fopen(FILE,">$prefs/ClickLog.txt");
		print FILE '';
		fclose(FILE);
		&redirect("$scripturl,v=admin,a=clicklog");
	}

	$title = $admintxt[79];
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url) {
 if(window.confirm("$admintxt[80]")) { location = url; }
}
// -->
</script>
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" align="center" width="750">
 <tr>
  <td bgcolor="$color{'titlebg'}" colspan="6"><font size="2"><b><img src="$images/clicklog_sm.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="6"><font size="1">$admintxt[81]<b><a href="$scripturl,v=admin,a=sets,l=log">$admintxt[82]</a></b>.</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="6"><font size="2"><b> $admintxt[84]</font><font size="1"> ($admintxt[83])</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan=6>
   <table cellpadding="3" cellspacing="0" width="100%">
EOT
	$totalips = 0;
	$counter = 0;
	fopen(FILE,"$prefs/ClickLog.txt");
	while(<FILE>) {
		chomp;
		($logtime,$ipaddy,$ref[$totalips],$page[$totalips],$info[$totalips]) = split(/\|/,$_);
		if($iplog{$ipaddy} eq '') {
			push(@ipaddyt,"$ipaddy");
			$iplog{$ipaddy} = 1;
		} else { ++$iplog{$ipaddy}; }
		if($page[$totalips] eq '') { $page[$totalips] = $admintxt[85]; }
		++$totalips;
	}
	fclose(FILE);
	if(!$totalips) { $totalips = 1; }

	foreach(@ipaddyt) { push(@ipaddy,"$iplog{$_}|$_"); }

	foreach(sort{$b <=> $a} @ipaddy) {
		($t,$ip) = split(/\|/,$_);
		$pper = ($iplog{$ip}/$totalips);
		$pper = sprintf("%.2f",($pper*100));
		print <<"EOT";
    <tr>
     <td align=right width="25%"><font size="2"><b><a href="$scripturl,v=admin,a=advipsearch,s=advsearch,ip=$ip" title="$admintxt[86]">$ip</a></b></font> </td>
     <td width="50%"><img src="$images/bar.gif" width="$pper%" height="10" alt="$pper%"></td>
     <td width="25%"><font size="1"> $iplog{$ip} $admintxt[87] ($pper%)</font></td>
    </tr>
EOT
		++$counter;
	}
		print <<"EOT";
    <tr>
     <td width=75% colspan=2 align=right><font size="2"><b>$admintxt[88]: </b></font></td>
     <td width=25%><font size="1"> $totalips $admintxt[87]</font></td>
    </tr><tr>
     <td width=75% colspan=2 align=right><font size="2"><b>$admintxt[89]: </b></font></td>
     <td width=25%><font size="1"> $counter $admintxt[90]</font></td>
    </tr>
EOT
	$cntb = 0;
	$cnto = 0;
	for($i = 0; $i < @info; $i++) {
		$fndb = 0;
		$fndo = 0;
		$_ = $info[$i];
		$ost = $_;
		if($ost =~ s/Windows ([A-Za-z0-9. ]{2,8})//) { $os = "Windows $1"; }
		elsif($ost =~ s/Win([ 0-9.]{2,8})//) { $os = "Windows $1"; }
		elsif($ost =~ s/Linux([ 0-9.]{2,8})//) { $os = "Linux $1"; }
			else { $os = "Unknown"; }
		if($ost =~ s/Opera ([0-9.A-Za-z]{2,9})// || $ost =~ s/Opera\/([0-9.A-Za-z]{2,9})//) { $browser = "Opera $1"; }
		elsif($ost =~ s/MSIE ([0-9.A-Za-z]{2,9})//) { $browser = "Microsoft Internet Explorer $1"; }
		elsif($ost =~ s/Netscape ([0-9.A-Za-z]{2,9})//) { $browser = "Netscape $1"; }
		elsif($ost =~ s/Gecko\/([0-9]{4})([0-9]{2})([0-9]{2})//) { $browser = "Gecko ($2.$3.$1)"; }
		elsif($ost =~ s/Gecko//) { $browser = "Gecko"; }
		elsif($ost =~ s/Mozilla\/([0-9.A-Za-z]{2,9})//) { $browser = "Mozilla $1"; }
		elsif($ost =~ s/PHP\/([0-9.A-Za-z]{2,9})//) { $browser = "PHP $1"; $os = "PHP $1"; }
		elsif($ost =~ s/bot//) { $browser = "Online Search Bot"; $os = "Online Search Bot"; }
			else { $browser = "Unknown"; }
		if($os =~ s/NT 5.0//) { $os .= "2000"; }
		if($os =~ s/NT 5.1//) { $os .= "XP"; }
		foreach (@osr) { if($os eq $_) { $fndo = 1; last; } }
		foreach (@tbro) { if($browser eq $_) { $fndb = 1; last; } }
		if(!$fndb) { push(@tbro,$browser); }
		if(!$fndo) { push(@osr,$os); }
		++$oscnt{$os};
		++$brcnt{$browser};
	}
	$oscnt = @osr;
	$browsercnt = @tbro;
	print <<"EOT";
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="6"><font size="2"><b> $admintxt[91] ($oscnt)</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="6"><font size="2">
EOT
	foreach(sort @osr) {
		$percent = sprintf("%.2f",(($oscnt{$_}/$totalips)*100));
		print qq~  <font size="1">$oscnt{$_} $admintxt[87] ($percent%)  -  </font>$_<br>\n~;
	}
	print <<"EOT";
  </font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="6"><font size="2"><b> $admintxt[92] ($browsercnt)</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="6"><font size="2">
EOT
	foreach(sort @tbro) {
		$percent = sprintf("%.2f",(($brcnt{$_}/$totalips)*100));
		print qq~  <font size="1">$brcnt{$_} $admintxt[87] ($percent%)  -  </font> $_<br>\n~;
	}
	for($i = 0; $i < @ref; $i++) {
		$fnd = 0;
		++$refers{$ref[$i]};
		foreach (@list) {
			if($_ eq "$ref[$i]") { $fnd = 1; last; }
		}
		if(!$fnd && $ref[$i] ne '') { push(@list,$ref[$i]); }
	}
	$refcnt = @list;
	print <<"EOT";
  </font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="6"><font size="2"><b> $admintxt[93] ($refcnt)</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="6"><font size="2">
EOT
	$cnt = 0;
	foreach(@list) { print qq~<font size="1">$refers{$_} $admintxt[87] - </font><a href="$_">$_</a><br>~; }
	if($list[0] eq '') { print "  $admintxt[94]\n"; }
	for($i = 0; $i < @page; $i++) {
		$fnd = 0;
		$page[$i] =~ s/^,//gsi;
		++$pv{"$page[$i]"};
		foreach (@nlist) {
			if($_ eq $page[$i]) { $fnd = 1; last; }
		}
		if(!$fnd && $page[$i] ne '') { push(@nlist,$page[$i]); }
	}
	$pagecnt = @nlist;
	print <<"EOT";
  </font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="6"><font size="2"><b> $admintxt[95]</font><font size="1"> ($pagecnt, $admintxt[83])</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="6"><font size="2">
EOT
	foreach(@nlist) { push(@nlists,"$pv{$_}|$_"); }

	foreach (sort{$b <=> $a} @nlists) {
		($hits,$page) = split(/\|/,$_);
		$percent = sprintf("%.2f",(($hits/$totalips)*100));
		if($page eq $admintxt[85]) { $vurl = ''; $vname = $admintxt[85]; } else { $vurl = $page; $vname = $page; }
		print qq~  <font size="1">$hits $admintxt[87] ($percent%) - </font><a href="$rurl,$vurl">$vname</a><br>\n~;
	}
	if($page[0]) { print <<"EOT";
 </font><tr>
  <td bgcolor="$color{'catbg'}" align="center" colspan="6"><font size="1"><a href="javascript:clear('$scripturl,v=admin,a=clicklog,p=delete')"><b>$admintxt[96]</b></a></font></td>
 </tr>
EOT
	}
	print <<"EOT";
  </td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub ErrorLog {
	if($URL{'p'} eq 'delete') {
		unlink("$prefs/ELog.txt");
		redirect("$scripturl,v=admin,a=errorlog");
	}
	$clog = 1;

	$title = $admintxt[117];
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url) {
 if(window.confirm("$admintxt[80]")) { location = url; }
}
// -->
</script>
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="100%">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/warning.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">$admintxt[118]</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b> $admintxt[119]</b></font></td>
 </tr>
EOT

	if(!$logip) { print <<"EOT";
 <tr>
  <td align="center" bgcolor="$color{'win'}"><font size="2"><b>$admintxt[120]</b></font></td>
 </tr>
EOT
		$clog = 0;
	}
		fopen(FILE,"$prefs/ELog.txt");
		@elog = <FILE>;
		fclose(FILE);
		if(!$elog[0] && $kelog) { print <<"EOT";
 <tr>
  <td align="center" bgcolor="$color{'win'}"><font size="2"><b>$admintxt[121]</b></font></td>
 </tr>
EOT
		$clog = 0;
	} else {
		foreach (reverse @elog) {
			chomp;
			($desc,$reason,$logtime,$lusername,$url) = split (/\|/,$_);
			&loaduser($lusername);
			if($userset{$lusername}->[1] eq '') { $user = $lusername; }
				else { $user = qq~<a href="$scripturl,v=profile,a=view,u=$lusername">$userset{$lusername}->[1]</a>~; }
			$loggedtime = &get_date($logtime);
			$alinkurl = qq~<a href="$url" title="$admintxt[122]">~;
			print <<"EOT";
 <tr>
  <td bgcolor="$color{'win2'}"><font size="2">$desc</font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1"><b>$admintxt[123]:</b> $loggedtime | <b>$admintxt[124]:</b> $user | <b>URL:</b> $alinkurl $url</font></td>
 </tr>
EOT
		}
	}

	if($clog) { print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}" align="center"><font size="1"><a href="javascript:clear('$scripturl,v=admin,a=errorlog,p=delete')"><b>$admintxt[96]</b></a></font></td>
 </tr>
EOT
	}

	print "</table>";
	&footer;
	exit;
}

sub IPLog {
	if($URL{'p'} eq 'delete') {
		unlink("$prefs/IpLog.txt");
		&redirect("$scripturl,v=admin,a=iplog");
	}
	$clog = 1;

	$title = $admintxt[125];
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url) {
 if(window.confirm("$admintxt[80]")) { location = url; }
}
// -->
</script>
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" colspan="4"><font size="2"><b><img src="$images/login_sm.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="4"><font size="1">$admintxt[126]</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" align="center" width="25%"><font size="1"><b>$admintxt[127]</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="20%"><font size="1"><b>$admintxt[128]</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="25%"><font size="1"><b>$admintxt[129]</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="30%"><font size="1"><b>$admintxt[130]</b></font></td>
 </tr>
EOT

	if(!$logip) { print <<"EOT";
 <tr>
  <td colspan="4" align="center" bgcolor="$color{'win'}"><font size="2"><b>$admintxt[120]</b></font></td>
 </tr>
EOT
		$clog = 0;
	}
		fopen(FILE,"$prefs/IpLog.txt");
		@iplog = <FILE>;
		fclose(FILE);
		if(!$iplog[0] && $logip == 1) { print <<"EOT";
 <tr>
  <td colspan="4" align="center" bgcolor="$color{'win'}"><font size="2"><b>$admintxt[131]</b></font></td>
 </tr>
EOT
		$clog = 0;
	} else {
		foreach (reverse @iplog) {
			chomp;
			($lusername,$loginout,$ipaddr,$logtime) = split (/\|/,$_);
			&loaduser($lusername);
			if($userset{$lusername}->[1] eq '') { $userset{$lusername}->[1] = $lusername; }
				else { $userset{$lusername}->[1] = qq~<a href="$scripturl,v=profile,a=view,u=$lusername">$userset{$lusername}->[1]</a>~; }
			$loginout = $loginout == 1 ? $admintxt[132] : $admintxt[133];
			$loggedtime = &get_date($logtime);
			print <<"EOT";
 <tr>
  <td bgcolor="$color{'win'}" align="center"><font size="2">$userset{$lusername}->[1]</font></td>
  <td bgcolor="$color{'win2'}" align="center"><font size="2">$loginout</font></td>
  <td bgcolor="$color{'win'}" align="center"><font size="2">$ipaddr</font></td>
  <td bgcolor="$color{'win2'}" align="center"><font size="1">$loggedtime</font></td>
 </tr>
EOT
		}
	}

	if($clog) { print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}" align="center" colspan="4"><font size="1"><b><a href="javascript:clear('$scripturl,v=admin,a=iplog,p=delete')">$admintxt[96]</a></b></font></td>
 </tr>
EOT
	}

	print "</table>";
	&footer;
	exit;
}

sub Temp {
	fopen(FILE,"$root/template.html") || &error("$admintxt[134] 'template.html'!",1);
	@stemp = <FILE>;
	fclose(FILE);
	chomp @stemp;
	foreach(@stemp) {
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		$temps1 .= "$_\n";
	}

	fopen(FILE,"$prefs/Smilies.html");
	@stemp = <FILE>;
	fclose(FILE);
	chomp @stemp;
	foreach(@stemp) {
 		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		$temps2 .= "$_\n";
	}

	$title = "Edit Templates";
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="100%" align="center">
 <tr>
  <td bgcolor="$color{'catbg'}" colspan="2"><font size="2"><b><img src="$images/xx.gif"> $admintxt[135]</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">$admintxt[136]:<br>&lt;blah v="\$variable"&gt;</font></td>
 </tr><tr><form action="$scripturl,v=admin,a=temp2" method="post" name="post">
  <td bgcolor="$color{'titlebg'}" width="50%"><font size="2"><b><img src="$images/xx.gif"> $admintxt[137]</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" align="center"><textarea rows="15" cols="140" name="temp1">$temps1</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'titlebg'}" width="50%" colspan="2"><font size="2"><b><img src="$images/smiley.gif"> $admintxt[138]</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" align="center" colspan="2"><textarea rows="15" cols="140" name="temp2">$temps2</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" align="center" colspan="2"><input type="submit" name="submit" value="$admintxt[139]"></td>
 </form></tr>
</table>
EOT

	&footer;
	exit;
}

sub Temp2 {
	fopen(FILE,"+>$root/template.html",1);
	print FILE $FORM{'temp1'};
	fclose(FILE);

	fopen(FILE,"+>$prefs/Smilies.html",1);
	print FILE $FORM{'temp2'};
	fclose(FILE);
	&redirect("$scripturl,v=admin");
}

sub Repop {
	if($URL{'p'} eq '') {
		$title = $admintxt[140];
		&header;
		print <<"EOF";
<table bgcolor="$color{'border'}" cellpadding=4 cellspacing=1 align="center" width=500>
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/ban.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">$admintxt[141]</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}"><font size="2"><b> <a href="$scripturl,v=admin,a=repop,p=start">$admintxt[142]</a></b></font><br><font size="1"><img src="$images/warning.gif"> $admintxt[143]</font></td>
 </tr>
</table>
EOF
		&footer;
		exit;
	}

	fopen(FILE,">$root/Maintance.lock");
	print FILE "\$maintance = 1;\n\$maintancer = qq~$admintxt[144]~;\n1;";
	fclose(FILE);

	foreach(@boardbase) {
		($cgs) = split("/",$_);
		fopen(FILE,"$boards/$cgs.msg");
		@msg = <FILE>;
		fclose(FILE);
		chomp @msg;
		$number = 0;
		$replycount = 0;
		@output = '';
		$puser = 0;
		$ptime = 0;
		foreach $msgs (@msg) {
			($tmess,$a,$b,$c,$replies,$poll,$f,$g) = split(/\|/,$msgs);
			$curnumber = -1;
			if($inu{$tmess}) { next; }
			if(!-s "$messages/$tmess.txt") { next; }
			fopen(FILE,"$messages/$tmess.txt");
			while( $countz = <FILE> ) {
				chomp $countz;
				($posted,$t,$t,$t,$lp) = split(/\|/,$countz);
				++$curnumber;
			}
			fclose(FILE);
			$replycount = $curnumber+$replycount;
			++$number;
			$inu{$tmess} = 1;
			if($poll) {
				fopen(FILE,"$messages/$tmess.polled");
				@last = <FILE>;
				fclose(FILE);
				chomp @last;
				$lloc = @last-1;
				($poller,$ptime) = split(/\|/,$last[$lloc]);
				if($ptime && $ptime > $lp) { $posted = $poller; $lp = $ptime; }
			}
			push(@output,"$lp|$tmess|$a|$b|$c|$curnumber|$poll|$f|$g|$posted");
		}
		$find = 0;
		fopen(FILE,"+>$boards/$cgs.msg");
		foreach $last (sort{$b <=> $a} @output) {
			($lp,$tmess,$a,$b,$c,$curnumber,$e,$f,$g,$posted) = split(/\|/,$last);
			if($find == 0) { $puser = $posted; $ptime = $lp; ++$find; }
			if($tmess eq '') { next; }
			print FILE "$tmess|$a|$b|$c|$curnumber|$e|$f|$g|$lp|$posted\n";
		}
		fclose(FILE);
		$replycount = $replycount+$number;
		fopen(FILE,"+>$boards/$cgs.ino");
		print FILE "$number\n$replycount\n";
		fclose(FILE);
	}
	unlink("$root/Maintance.lock");
	if($URL{'a'} eq 'remove') { return; }
	$title = $admintxt[140];
	&header;
	print <<"EOF";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" align="center" width="400">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" align="center"><font size="2">$admintxt[145]</font></td>
 </tr>
</table>
EOF
	&footer;
	exit;
}

sub EditCats {
	require("$code/ManageCats.pl");
	&EditCatsR;
	exit;
}

sub EditBoards {
	require("$code/ManageBoards.pl");
	if($URL{'g'} eq '2') { &EditBoards2; }
	elsif($URL{'g'} eq '3') { &EditBoards3; }
	if($URL{'p'} eq 'move') { &MoveBoards; }
	if($URL{'p'} eq 'moveboard') { &MoveToCat; }
	&StartBoards;
}

sub Version {
	opendir(DIR,$code);
	@alldir = readdir(DIR);
	closedir(DIR);
	foreach(@alldir) { $size += -s("$code/$_"); }
	$size = sprintf("%.2f",($size/1024));

	require("$code/Themes.pl");

	$title = $admintxt[146];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="500" align="center">
 <tr><form action="http://www.eblah.com/check.php" method="post" name="check">
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/question.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">$admintxt[147]</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}"><input type="hidden" name="version" value="$version"><font size="2"><b>
   <img src="$images/open_thread.gif"> e-blah! $admintxt[148]</b><br><font size="1">
<b> $admintxt[149]:</b> $version<br>
<b>- $admintxt[150]:</b> $bversion<br>
<b>- $admintxt[151]:</b> $themever ... <b>$admintxt[152]:</b> $themesupp<br>
<b> $admintxt[153]:</b> $size KB<br>
<b> Perl:</b> $]<br>
<b> $admintxt[154]:</b> $ENV{'SERVER_SOFTWARE'}</font></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><input type="submit" value=" $admintxt[155] "></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub News {
	if($URL{'p'} == 2) {
		fopen(FILE,"+>$prefs/News.txt");
		print FILE "$FORM{'news'}";
		fclose(FILE);
		&redirect("$scripturl,v=admin");
	}
	fopen(FILE,"$prefs/News.txt");
	@news = <FILE>;
	fclose(FILE);
	chomp @news;
	foreach(@news) { $news .= "$_\n"; }
	$title = $admintxt[156];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellspacing="1" cellpadding="4" width="550" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/news.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">$admintxt[157]</font></td>
 </tr><tr><form action="$scripturl,v=admin,a=news,p=2" method="post" name="msend">
  <td bgcolor="$color{'win2'}" align="center"><textarea name="news" wrap="virtual" rows="8" cols="100">$news</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><input type="submit" value=" $admintxt[158] "></td>
 </form></tr>
</table>
EOT
	&footer;
	exit;
}
1;
