####################################################
# Blah Software Code      |    Software Version: 2 #
####################################################
#       Software: e-blah!                          #
# Copyrighted  2001-2002 e-blah!                  #
# All Rights Reserved                              #
####################################################

require("$language/Calendar.lng");

use Time::Local 'timelocal';

sub Cal {
	if($URL{'a'} eq 'year') { &Year; }
	elsif($URL{'s'}) { &ShowMore; }
		else { &Month; }
}

sub Month {
	($t,$t,$t,$thisday,$thismon,$thisyr) = localtime(time+(3600*$settings[15]));
	if($URL{'m'} eq $thismon || $URL{'m'} < 0 || $URL{'m'} > 11) { $URL{'m'} = ''; }
	if($URL{'m'} ne '' && $URL{'m'} < 12) { $thismon = $URL{'m'}; }
	# if($URL{'y'}) { $
	$useyr = $URL{'y'} ? $URL{'y'} : ($thisyr+1900);
	eval { $mstart = timelocal(1,1,1,1,$thismon,$useyr,1); };
	($t,$t,$t,$qmday,$qmon,$qyear,$qwday,$qyday) = localtime($mstart);

	fopen(FILE,"$members/List.txt") || &error($calendar[1]);
	@loadlist = <FILE>;
	fclose(FILE);
	chomp @loadlist;
	foreach(@loadlist) {
		loaduser($_);
		if(!$userset{$_}->[16]) { next; }
		($bmon,$day,$year) = split("/",$userset{$_}->[16]);
		$bmon = $bmon-1;
		if($bmon eq $qmon) {
			$bday = $day*1;
			$tbday = datest($bday);
			if(length($year) == 2) { $year = $year+1900; }
			$bdays{$bday} .= qq~<a href="$scripturl,v=profile,a=view,u=$_" title="$months[$bmon] $tbday, $year">$userset{$_}->[1]</a>, ~;
			++$bdaysc{$bday};
		}
	}

	fopen(FILE,"$prefs/Events.txt");
	@events = <FILE>;
	fclose(FILE);
	chomp @events;
	if($URL{'p'} eq 'save') { &CalendarSave; }
	foreach(@events) {
		($number,$edate,$sum) = split(/\|/,$_);
		($t,$t,$t,$tday,$tmon,$year) = localtime($edate);
		$year = $year+1900;
		unless(($thismon == $tmon) && ($year == $useyr || $year == 1990)) { next; }
		$tbday = datest($tday);
		$year = ', '.$year;
		if($year eq ', 1990') { $year = ''; }
		$events{$tday} .= qq~<a href="$scripturl,v=cal,s=$number" title="$months[$qmon] $tbday$year">$sum</a>, ~;
		++$eventsc{$tday};
	}

	$year = $qyear+1900;

	$title = "$months[$qmon] $year";
	&header;
	print <<"EOT";
<table cellpadding="4" cellspacing="1" bgcolor="$color{'border'}" width="750" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" colspan="7"><font size="2"><b><img src="$images/cal_sm.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" align="center" width="14%"><font size="2"><b>$days[0]</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="14%"><font size="2"><b>$days[1]</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="14%"><font size="2"><b>$days[2]</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="15%"><font size="2"><b>$days[3]</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="14%"><font size="2"><b>$days[4]</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="14%"><font size="2"><b>$days[5]</b></font></td>
  <td bgcolor="$color{'catbg'}" align="center" width="14%"><font size="2"><b>$days[6]</b></font></td>
 </tr>
EOT
	if($qwday > 0) {
		print <<"EOT";
 <tr>
  <td bgcolor="$color{'win'}" height="85" colspan="$qwday"></td>
EOT
	}

	$days = CheckDays($qmon);

	$daycnt = 1;
	++$qwday;
	for($i = $qwday; $i <= 7; $i++) {
		$userbdays = '';
		if($thisday == $daycnt && $URL{'m'} eq '') { $color = $color{'win'}; }
			else { $color = $color{'win2'}; }
		if($bdays{$daycnt}) { $bdays{$daycnt} =~ s/, \Z//; $userbdays = "<b>$bdaysc{$daycnt} $calendar[2]:</b> $bdays{$daycnt}<br>"; }
		if($events{$daycnt}) { $events{$daycnt} =~ s/, \Z//; $userbdays .= "<b>$eventsc{$daycnt} $calendar[3]:</b> $events{$daycnt}"; }
		$daycnta = $settings[4] eq 'Administrator' ? qq~<a href="$scripturl,v=admin,a=calendar,m=$qmon,d=$daycnt">$daycnt</a>~ : $daycnt;
		print <<"EOT";
  <td bgcolor="$color" height="85" valign="top"><font size="1">$daycnta<br>$userbdays</font></td>
EOT
		if($i == 7 && $days > $daycnt) { print "</tr>"; $i = 0; }
		if($days == $daycnt) { last; }
		++$daycnt;
	}
	if($i != 7) {
		$alldays = 7-$i;
		print <<"EOT";
  <td bgcolor="$color{'win'}" height="85" valign="top" colspan="$alldays"></td>
EOT
	}

	$sel{$qmon} = ' selected';
	for($x = 0; $x < 12; ++$x) { $current .= qq~<option value="$x"$sel{$x}>$months[$x]</option>\n~; }
	$yrs{$useyr} = " selected";
	for($ey = -2; $ey < 3; $ey++) {
		$curyr = $useyr+$ey;
		$yearzz .= qq~<option value="$curyr"$yrs{$curyr}>$curyr</option>~;
	}

	print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}" colspan="7">
   <table cellpadding="0" width="100%">
    <tr>
     <td><font size="1"><b>$calendar[29]:
<script language="JavaScript">
<!--
function JumpTo(ghere,year) {
 location = "$scripturl,v=cal,m="+ghere+",y="+year;
}
//-->
</script><select name="JumpZ" onChange="JumpTo(this.value,$year);">$current</select>,<select name="JumpZ" onChange="JumpTo($qmon,this.value);">$yearzz
     </select></b></font></td>
     <td align="right"><font size="1"><b><a href="$scripturl,v=cal,a=year" title="$calendar[6]: $year">$calendar[6]</a></b></font></td>
    </tr>
   </table>
  </td>
 </tr>
</table>
EOT

	&footer;
	exit;
}

sub ShowMore {
	fopen(FILE,"$prefs/Events.txt");
	@events = <FILE>;
	fclose(FILE);
	chomp @events;
	foreach(@events) {
		($number,$edate,$sum,$f) = split(/\|/,$_);
		($t,$t,$t,$tday,$tmon,$tyear) = localtime($edate);
		if($URL{'s'} eq $number) { $summary = $sum; $message = Unformat($f); $yr = $tyear; $sday = $tday; $smonth = $tmon; }
	}
	if($summary eq '') { &error("The topic you selected is invalid."); }
	if($yr == 90) { $bmonth = "Every "; } else { $syear = $yr+1900; }
	&BC;
	$sday = datest($sday);
	$title = $calendar[8];
	&header;
	print <<"EOT";
<table cellpadding="4" cellspacing="1" bgcolor="$color{'border'}" width="100%">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/cal_sm.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}">
   <table cellpadding="4" cellspacing="0" width="100%">
    <tr>
     <td align="right" width="35%"><font size="2"><b>$calendar[9]:</b></font></td>
     <td width="65%"><font size="2">$summary</font></td>
    </tr><tr>
     <td align="right" width="35%"><font size="2"><b>$calendar[10]:</b></font></td>
     <td width="65%"><font size="2">$bmonth$months[$smonth] $sday $syear</font></td>
    </tr><tr>
     <td align="right" width="35%"><font size="2"><b>$calendar[8]:</b></font></td>
     <td width="65%"><font size="2">$message</font></td>
    </tr>
   </table>
  </td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub Year {
	$title = "Full Year";
	&header;
	($t,$t,$t,$thisday,$thismon,$thisyr) = localtime(time+(3600*$settings[15]));
	$year = $thisyr+1900;
	$todayis = $thisday;
	$todaymon = $thismon;
	print <<"EOT";
<table cellpadding="2" cellspacing="0" width="850" align="center">
 <tr>
EOT
	$moncnt = 0;
	$h = 0;
	for($z = 0; $z <= 4; $z++) {
		++$h;
		eval { $mstart = timelocal(1,1,1,1,$moncnt,$thisyr,1); };
		($t,$t,$t,$qmday,$qmon,$qyear,$qwday,$qyday) = localtime($mstart);

		if($h == 1 && $moncnt > 0) { print "<tr>\n"; }

		print <<"EOT";
  <td valign="top">
   <table cellpadding="4" cellspacing="1" bgcolor="$color{'border'}" width="9%">
    <tr>
     <td bgcolor="$color{'titlebg'}" align="center" colspan="7"><font size="1"><b> <a href="$scripturl,v=cal,m=$qmon">$months[$qmon] $year</a> </b></font></td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" align="center" width="5"><font size="1"><b>$sdays[0]</b></font></td>
     <td bgcolor="$color{'catbg'}" align="center" width="5"><font size="1"><b>$sdays[1]</b></font></td>
     <td bgcolor="$color{'catbg'}" align="center" width="5"><font size="1"><b>$sdays[2]</b></font></td>
     <td bgcolor="$color{'catbg'}" align="center" width="5"><font size="1"><b>$sdays[3]</b></font></td>
     <td bgcolor="$color{'catbg'}" align="center" width="5"><font size="1"><b>$sdays[4]</b></font></td>
     <td bgcolor="$color{'catbg'}" align="center" width="5"><font size="1"><b>$sdays[5]</b></font></td>
     <td bgcolor="$color{'catbg'}" align="center" width="5"><font size="1"><b>$sdays[6]</b></font></td>
    </tr>
EOT
		if($qwday > 0) {
			print <<"EOT";
    <tr>
     <td bgcolor="$color{'win'}" height="5" colspan="$qwday"></td>
EOT
		}

		$days = &CheckDays($qmon);

		$daycnt = 1;
		++$qwday;
		for($i = $qwday; $i <= 7; $i++) {
			if($todayis == $daycnt && $todaymon eq $qmon) { $color = $color{'win'}; } else { $color = $color{'win2'}; }
			$daycnta = $settings[4] eq 'Administrator' ? qq~<a href="$scripturl,v=admin,a=calendar,m=$qmon,d=$daycnt">$daycnt</a>~ : $daycnt;
			print <<"EOT";
     <td bgcolor="$color" height="5" align="center"><font size="1">$daycnta</font></td>
EOT
			if($i == 7 && $days > $daycnt) { print "    </tr>\n"; $i = 0; }
			if($days == $daycnt) { last; }
			++$daycnt;
		}
		if($i != 7) {
			$alldays = 7-$i;
			print <<"EOT";
     <td bgcolor="$color{'win'}" height="5" colspan="$alldays"></td>
EOT
	}

	print <<"EOT";
   </table>
  </td>
EOT
		if($h == 4) { print " </tr>"; $h = 0; $z = 0; }
		if($moncnt == 11) { last; }
		++$moncnt;
	}
	print "</table>";
	&footer;
	exit;
}

sub CalendarEvents {
	if($URL{'e'} ne '') { 1; }
	elsif($URL{'m'} eq '' || $URL{'d'} eq '') { &error($calendar[12]); }
	fopen(FILE,"$prefs/Events.txt");
	@events = <FILE>;
	fclose(FILE);
	chomp @events;
	if($URL{'p'} eq 'save') { &CalendarSave; }
	foreach(@events) {
		($number,$edate,$sum,$f) = split(/\|/,$_);
		($t,$t,$t,$tday,$tmon,$year) = localtime($edate);
		if($URL{'e'} && $URL{'e'} eq $number) { $summary = $sum; $full = Unformat($f); $yr = $year; $URL{'d'} = $tday; $URL{'m'} = $tmon; $remove = qq~ <input type="submit" value=" $calendar[13] " name="remove">~; }
		if($tday == $URL{'d'} && $URL{'m'} == $tmon) { $events .= qq~<b>$calendar[14]:</b> <a href="$scripturl,v=admin,a=calendar,e=$number">$sum</a><br>~; }
	}
	if(!$yr && $URL{'e'}) { &error("$gtxt{'error2'}"); }
	($t,$t,$t,$t,$t,$qyear) = localtime(time);
	for($ey = 0; $ey < 10; $ey++) {
		$s = '';
		$pdate = $qyear+$ey;
		$sdate = ($pdate)+1900;
		if($yr && $yr == $pdate) { $s = " selected"; $ss = 1; }
		$ops .= qq~     <option value="$pdate"$s>$sdate</option>\n~;
	}
	if(!$ss) { $s = " selected"; }
	$ops .= qq~     <option value="90"$s>$calendar[15]</option>\n~;

	if(!$events) { $events = $calendar[16]; }
	if($URL{'e'}) { $edit = $calendar[17]; } else { $edit = $calendar[18]; }
	$title = $calendar[19];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/cal_sm.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">$calendar[20]</font></td>
 </tr>
EOT
	if(!$URL{'e'}) {
		print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b>- $calendar[21]</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}"><font size="2">$events</font></td>
 </tr>
EOT
	}
	print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b>- $edit</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}">
   <table cellpadding="4" cellspacing="0" width="100%">
    <tr><form action="$scripturl,v=admin,a=calendar,m=$URL{'m'},d=$URL{'d'},e=$URL{'e'},p=save" method="post" name="msend">
     <td align="right" width="30%"><font size="2"><b>$calendar[22]:</b></font></td>
     <td><input type="text" name="sum" maxlength="50" size="30" value="$summary"></td>
    </tr>
   </table>
  </td>
 </tr>
EOT
	if($BCLoad) {
		print <<"EOT";
 <tr>
  <td bgcolor="$color{'win2'}"><script language="JavaScript" src="$bcloc" type="text/javascript"></script>
   <table cellpadding="4" cellspacing="0" width="100%">
    <tr>
     <td align="right" width="30%" valign="top"><font size="2"><b>$calendar[23]:</b></font></td>
     <td width="47%"><a href="javascript:use('[face=Arial]','[/face]');"><img src="$images/face.gif" border="0" alt="$var{'8'}"></a>
      <a href="javascript:use('[size=2]','[/size]');"><img src="$images/size.gif" border="0" alt="$var{'9'}"></a>
      <a href="javascript:use('[b]','[/b]');"><img src="$images/bold.gif" border="0" alt="$var{'10'}"></a>
      <a href="javascript:use('[i]','[/i]');"><img src="$images/italics.gif" border="0" alt="$var{'11'}"></a>
      <a href="javascript:use('[u]','[/u]');"><img src="$images/underline.gif" border="0" alt="$var{'12'}"></a>
      <a href="javascript:use('[left]','[/left]');"><img src="$images/left.gif" border="0" alt="$var{'13'}"></a>
      <a href="javascript:use('[center]','[/center]');"><img src="$images/center.gif" border="0" alt="$var{'14'}"></a>
      <a href="javascript:use('[right]','[/right]');"><img src="$images/right.gif" border="0" alt="$var{'15'}"></a>
      <a href="javascript:use('[pre]','[/pre]');"><img src="$images/pre.gif" border="0" alt="$var{'16'}"></a>
      <a href="javascript:use('[s]','[/s]');"><img src="$images/strike.gif" border="0" alt="$var{'17'}"></a>
      <a href="javascript:use('[list]\\n[*]','\\n[/list]');"><img src="$images/list.gif" border="0" alt="$var{'18'}"></a>
      <a href="javascript:use('[code]','[/code]');"><img src="$images/code.gif" border="0" alt="$var{'87'}"></a><br>
      <a href="javascript:use('[sub]','[/sub]');"><img src="$images/sub.gif" border="0" alt="$var{'19'}"></a>
      <a href="javascript:use('[sup]','[/sup]');"><img src="$images/sup.gif" border="0" alt="$var{'20'}"></a>
      <a href="javascript:use('[url]','[/url]');"><img src="$images/url.gif" border="0" alt="$var{'21'}"></a>
      <a href="javascript:use('[mail]','[/mail]');"><img src="$images/email_click.gif" border="0" alt="$var{'22'}"></a>
      <a href="javascript:use('[img]','[/img]');"><img src="$images/img.gif" border="0" alt="$var{'23'}"></a>
      <a href="javascript:use('[quote]','[/quote]');"><img src="$images/quote_click.gif" border="0" alt="$var{'24'}"></a>
      <a href="javascript:use('[hr]');"><img src="$images/hr.gif" border="0" alt="$var{'25'}"></a>
      <a href="javascript:use('[flash width=200 height=200 url=',']');"><img src="$images/flash.gif" border="0" alt="$var{'86'}"></a>
      <a href="javascript:use('[table]\\n','[/table]');"><img src="$images/table.gif" border="0" alt="$var{'27'}"></a>
      <a href="javascript:use('[tr]\\n','[/tr]');"><img src="$images/tr.gif" border="0" alt="$var{'28'}"></a>
      <a href="javascript:use('[td]\\n','[/td]');"><img src="$images/td.gif" border="0" alt="$var{'29'}"></a></td>
      <td width="23%"><font size="1"><b>$var{'30'}: <select name="color" onChange="ChangeColor(this.value);">
       <option value="">$var{'31'}</option>
       <option value="white">$var{'32'}</option>
       <option value="black">$var{'33'}</option>
       <option value="purple">$var{'34'}</option>
       <option value="blue">$var{'35'}</option>
       <option value="darkblue">$var{'36'}</option>
       <option value="blue">$var{'37'}</option>
       <option value="cyan">$var{'38'}</option>
       <option value="green">$var{'39'}</option>
       <option value="yellow">$var{'40'}</option>
       <option value="orange">$var{'41'}</option>
       <option value="red">$var{'42'}</option>
       <option value="pink">$var{'43'}</option>
     </select></b></font></td>
    </tr>
   </table>
  </td>
 </tr>
EOT
	} elsif($BCSmile) { print qq~<script language="JavaScript" src="$bcloc" type="text/javascript"></script>~; }
	print <<"EOT";
 <tr>
  <td bgcolor="$color{'win'}">
   <table cellpadding="4" cellspacing="0" width="100%">
    <tr>
     <td align="right" width="30%" valign="top"><font size="2"><b>$calendar[24]:</b></font><br><br>
EOT
	if($BCSmile) {
		print <<"EOT";
      <table cellpadding="2" cellspacing="1" width="180" align="center" bgcolor="$color{'border'}">
       <tr>
        <td bgcolor="$color{'win2'}">
         <table cellpadding="2" cellspacing="0" width="100%">
          <tr>
           <td colspan="8"><font size="1"><b> $calendar[25]</b></font><td>
          </tr><tr>
           <td><a href="javascript:use(':)');"><img src="$simages/smiley.gif" border="0" alt="$var{'44'}"></a></td>
           <td><a href="javascript:use(';)');"><img src="$simages/wink.gif" border="0" alt="$var{'45'}"></a></td>
           <td><a href="javascript:use(':P');"><img src="$simages/tongue.gif" border="0" alt="$var{'46'}"></a></td>
           <td><a href="javascript:use(';D');"><img src="$simages/grin.gif" border="0" alt="$var{'47'}"></a></td>
           <td><a href="javascript:use(':(');"><img src="$simages/sad.gif" border="0" alt="$var{'48'}"></a></td>
           <td><a href="javascript:use('>:(');"><img src="$simages/angry.gif" border="0" alt="$var{'49'}"></a></td>
           <td><a href="javascript:use(':\\'(');"><img src="$simages/cry.gif" border="0" alt="$var{'50'}"></a></td>
           <td><a href="javascript:use(':X');"><img src="$simages/lipsx.gif" border="0" alt="$var{'51'}"></a></td>
          </tr><tr>
           <td><a href="javascript:use(':-/');"><img src="$simages/undecided.gif" border="0" alt="$var{'52'}"></a></td>
           <td><a href="javascript:use(':o');"><img src="$simages/shock.gif" border="0" alt="$var{'53'}"></a></td>
           <td><a href="javascript:use(':B');"><img src="$simages/blush.gif" border="0" alt="$var{'54'}"></a></td>
           <td><a href="javascript:use('8)');"><img src="$simages/cool.gif" border="0" alt="$var{'55'}"></a></td>
           <td><a href="javascript:use(':K)');"><img src="$simages/kiss.gif" border="0" alt="$var{'56'}"></a></td>
           <td><a href="javascript:use(':D');"><img src="$simages/lol.gif" border="0" alt="$var{'57'}"></a></td>
           <td><a href="javascript:use('::)');"><img src="$simages/roll.gif" border="0" alt="$var{'58'}"></a></td>
           <td><a href="javascript:use('??)');"><img src="$simages/huh.gif" border="0" alt="$var{'59'}"></a></td>
         </tr>
EOT
		if($upbc) {
			print <<"EOT";
          <tr>
           <td colspan="8" align="center"><font size="1"><a href="$scripturl,v=post,a=smilies" onClick="window.open('$scripturl,v=post,a=smilies','smiles','height=250,width=300,resizable=yes,scrollbars=yes'); return false;" target="smiles">$calendar[26]</a></font></td>
          </tr>
EOT
		}
		print <<"EOT";
        </table>
       </td>
      </tr>
     </table>
EOT
	}
	print <<"EOT";
    </td>
     <td><textarea name="message" wrap="virtual" rows="12" cols="70">$full</textarea></td>
    </tr><tr>
     <td align="right" valign="top"><font size="2"><b>$calendar[27]:</b></font></td>
     <td><select name="y">
$ops</select></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td align="center" bgcolor="$color{'win2'}"><input type="submit" value=" $calendar[28] " name="submit">$remove</td>
 </form></tr>
</table>
EOT
	&footer;
	exit;
}

sub CalendarSave {
	eval { $mstart = timelocal(1,1,1,$URL{'d'},$URL{'m'},$FORM{'y'},1); };
	$sum = Format($FORM{'sum'});
	$full = Format($FORM{'message'});
	if($sum eq '' || $full eq '') { &error($gtxt{'bfield'}); }
	if(!$URL{'e'}) {
		$count = time;
		fopen(FILE,"+>>$prefs/Events.txt");
		print FILE qq~$count|$mstart|$sum|$full\n~;
		fclose(FILE);
	} else {
		foreach(@events) {
			($count,$odate,$osum,$ofull) = split(/\|/,$_);
			if($count eq $URL{'e'} && $FORM{'remove'}) { next; }
			elsif($count eq $URL{'e'}) { $all .= "$count|$mstart|$sum|$full\n"; }
				else { $all .= "$_\n"; }
		}

		fopen(FILE,"+>$prefs/Events.txt");
		print FILE $all;
		fclose(FILE);
	}
	&redirect("$scripturl,v=admin,a=calendar,m=$URL{'m'},d=$URL{'d'}");
}
1;
